
// 2018-11-14 添加白名单规则  美通卡绑卡地址
/**
 galleon.Navigator
 galleon.Storage
 galleon.Sys = {
 getInfo : function() {},
 getStacks : function( res ) {
 ['asef','asdf','asdf']
 }
 }
 */


// var galleon = {
// 	Sys : {
// 		getInfo : function() {
// 			return '{version : "3.7.0"}';
// 		}
// 	},
// 	Navigator : {
// 		forward : function( url ) {
// 			console.log( '跳转' +url );
// 		}
// 	}
// };

(function () {
  function parseJSON(str) {
    if (typeof str != 'string') {
      return str;
    }

    try {
      return (new Function('return ' + str + ';'))();
    } catch (e) {
      return {};
    }
  }

  var handle, _fn,
    sysInfo = galleon.Sys.getInfo();


  sysInfo = parseJSON(sysInfo + ''); // 转字符 hack android bug

  if (typeof window == 'undefined') {
    window = {};
  }

  handle = {
    /**
     @url String 处理前url
     @context Object 执行上下文

     返回 pixie:stop 禁止往下执行
     */
    // forward拦截代码
    parseUri: function (uri, context) {
      uri = _fn.parseDShopUri(uri); // 解析dshop相关的规则
      return uri;
      //return ; //返回 pixie:stop 禁止往下执行
    },

    /**
     @url String 处理前url
     @context Object 执行上下文

     返回 pixie:stop 禁止往下执行
     */
    // 扫码页拦截代码
    parseScanUri: function (uri, context) {
      uri = _fn.parseDShopUri(uri);
      uri = _fn.whiteList(uri); // 处理扫码跳转的白名单
      uri = _fn.parseRNUri(uri); // 解析rn相关的规则
      return uri;
    }
  }


  _fn = {
    whiteList: function (uri) {
      uri = uri + '';
      if (uri.indexOf('.lsh123.com') > 0) { //放行链家的域
        galleon.Navigator.forward(uri, '');
        return 'pixie:stop';
      } else if (uri.indexOf('.wumart.com') > 0) {
        galleon.Navigator.forward(uri, '');
        return 'pixie:stop';
      } else if (uri.indexOf('.dmall.com/dac/card-binding/guideApp.html') > 0) { //匹配 guideApp 规则
        galleon.Navigator.forward(uri, '');
        return 'pixie:stop';
      }
      return uri;
    },

    parseDShopUri: function (uri) {
      var result,
        param;

      if (uri.indexOf('a.dmall.com') < 0 && uri.indexOf('static.dmall.com') < 0 && uri.indexOf('static.dmall.com/mini') < 0) {
        return uri; // 非dshop链接不处理
      }

      param = uri.split('?')[1] || '';
      param = param.split('#')[0] || '';
      param = _fn.paramToObj(param);
      if (_fn.isCoudan(uri, param)) { // 符合去凑单项目
        result = 'app://DMAddOnItemPage?' + uri.split('?')[1];
      } else if (_fn.isSmartCart(uri, param)) { // 符合智能购物车
        var paramStr = uri.split('?')[1] || '';
        paramStr = paramStr && paramStr.replace('redirectType=', 'redirectBiz='); //修改redirectType 参数key避免重复跳转
        galleon.Navigator.replace('https://static.dmall.com/kayak-project/h5/html/2017/smartcart.html?dmShowShare=false&dmShowCart=false&' + paramStr, '');
        result = 'pixie:stop';
      } else if (_fn.isMiniprogram(uri, param) && param.type * 1 == 3) { // 处理小程序扫码问题
        var paramStr = uri.split('?')[1];
        //console.log( 'https://static.dmall.com/kayak-project/h5/html/2017/smartcart.html?dmShowShare=false&dmShowCart=false&' + paramStr );
        galleon.Navigator.replace('https://static.dmall.com/kayak-project/h5/html/2017/smartcart.html?dmShowShare=false&dmShowCart=false&' + paramStr, '');
        result = 'pixie:stop';
      } /*else if ( _fn.isNormalDshopUri( uri, param ) ) { // 普通的dshop地址
        var uri = uri.split( '#' );

        uri[0] += uri[0].indexOf( '?' ) > -1 ? '' : '?';
        uri[0] += '&dmShowCart=false&dmShowShare=false';
        return uri.length == 2 ? uri[0] + '#' + uri[1] : uri[0];
      }*/

      result = result || uri;
      return result;
    },
    parseRNUri: function (uri) {
      var result;
      if (uri.indexOf('rn://') == 0) { //如果是以rn 协议打头的地址
        galleon.Navigator.forward(uri, '');
        return 'pixie:stop';
      } else { // 否则 不处理
        return uri;
      }
    },
    isCoudan: function (uri, param) {
      var redirectType = param.redirectType || '',
        targetVersion = param.redirectVersion || '';

      targetVersion = targetVersion.replace(/_/g, '.');
      if (_fn.versionIsBig(sysInfo.version, targetVersion) && param.redirectType == 'coudan') {
        return true;
      }
      return false;
    },

    isSmartCart: function (uri, param) {
      var redirectType = param.redirectType || '',
        targetVersion = param.redirectVersion || '';

      targetVersion = targetVersion.replace(/_/g, '.');
      if (_fn.versionIsBig(sysInfo.version, targetVersion) && param.redirectType == 'smartcart') {
        return true;
      }
      return false;
    },

    isMiniprogram: function (uri, param) {	// 不考虑情况
      if (uri.indexOf('static.dmall.com/mini') > -1) {
        return true;
      }
      return false;
    },

    isNormalDshopUri: function (uri, param) {
      // 已经被处理过的参数，有时要考虑死循环问题
      if (uri.indexOf('a.dmall.com') > -1 && (param.dmShowCart + '') == 'false' && (param.dmShowShare + '') == 'false') {
        return false;
      }
      return true;
    },

    // 对比版本，如果第一个大于 等于 第二个参数则反true否则反false
    versionIsBig: function (first, second) {
      first = first || '';
      second = second || '';
      var len, i;

      first = first.split('.');
      second = second.split('.');
      if (first.length == 0 && second.length > 0) {
        return false;
      }
      if (first.length > 0 && second.length == 0) {
        return true;
      }
      if (first.length == 0 && second.length == 0) {
        return false;
      }

      len = first.length >= second.length ? first.length : second.length;
      for (i = 0; i < len; ++i) {
        if ((first[i] || 0) * 1 > (second[i] || 0) * 1) {
          return true;
        } else if ((first[i] || 0) * 1 < (second[i] || 0) * 1) {
          return false;
        }
      }
      return true; // 全等于的情况
    },

    paramToObj: function (str) {
      str = str || '';
      var result = {},
        list = str.split('&'),
        p, i, len;

      for (i = 0, len = list.length; i < len; ++i) {
        p = (list[i] + '').split('=');
        if (p.length != 2) {
          continue;
        }
        result[p[0]] = p[1];
      }
      return result;
    }
  }

  //var result = handle.parseScanUri('https://a.dmall.com/act/wFkq0RQDl1ti.html?erpStoreId=230&dmfrom=wx&from=wx&shareKey=1524467832738');
  //console.log( result );
  window.pixie = handle;
})();
