package com.wm.dmall.views.categorypage.waredetail

import android.content.Context
import android.support.v7.widget.RecyclerView
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.TextView
import com.wm.dmall.R
import com.wm.dmall.business.dto.waredetail.WareDetailEditorItemModel

/**
 * Author： fanyafeng
 * Date： 2019-12-27 19:34
 * Email: fanyafeng@live.cn
 */
class WareDetailEditorItemAdapter(val context: Context, val list: List<WareDetailEditorItemModel>) : RecyclerView.Adapter<WareDetailEditorItemAdapter.WareDetailEditorItemViewHolder>() {


    var onItemClickListener: ((view: View, position: Int, model: WareDetailEditorItemModel) -> Unit)? = null

    private var onInnerItemClickListener: ((view: View, position: Int, model: WareDetailEditorItemModel) -> Unit) = { view, position, model ->
        onItemClickListener?.invoke(view, position, model)
    }

    var onItemClick: OnItemClick? = null

    interface OnItemClick {
        fun onItemClick(view: View, position: Int, model: WareDetailEditorItemModel)
    }


    override fun onCreateViewHolder(parent: ViewGroup, position: Int): WareDetailEditorItemViewHolder {
        val view = LayoutInflater.from(context).inflate(R.layout.item_tag_layout, parent, false)
        return WareDetailEditorItemViewHolder(view)
    }

    override fun getItemCount(): Int {
        return list.size
    }

    override fun onBindViewHolder(holder: WareDetailEditorItemViewHolder, position: Int) {
        val model = list[position]
        holder.tvSaleTag?.text = model.tag
        holder.itemView.setOnClickListener {
            onInnerItemClickListener.invoke(it, position, model)
            onItemClick?.onItemClick(it, position, model)
        }
    }


    inner class WareDetailEditorItemViewHolder(itemView: View) : RecyclerView.ViewHolder(itemView) {

        var tvSaleTag: TextView? = null

        init {
            tvSaleTag = itemView.findViewById(R.id.tvSaleTag)
        }

    }
}